"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const lru_cache_1 = __importDefault(require("lru-cache"));
const hash_sum_1 = __importDefault(require("hash-sum"));
const cache = new lru_cache_1.default({ max: 250 });
function default_1(creator, ...argsKey) {
    const cacheKey = (0, hash_sum_1.default)(argsKey.join(''));
    // source-map cache busting for hot-reloadded modules
    let output = cache.get(cacheKey);
    if (output) {
        return output;
    }
    output = creator();
    cache.set(cacheKey, output);
    return output;
}
exports.default = default_1;
